typedef struct Display_struct Display;
struct Display_struct;

typedef struct WM_struct WM;
struct WM_struct;

typedef struct Window_struct Window;
struct Window_struct;

typedef struct Conn_struct Conn;

#include "event.h"

struct Conn_struct {
	Conn *next;
	int fd;
	YwConnection *conn;

	enum {
		st_not_connected,
		st_alive,
		st_dead
	} state;

	enum {
		normal_client,
		display,
		window_manager
	} type;

	int cid;

	int alive;

	Display *display;
	WM *wm;

	int current_win_id;
	Window *wins;
	int goto_id, wm_goto_id;

	YwLock event_lock;
	int nevents;
	Event *events;
};

	
/* global {{{ */
extern int current_cid;
extern Conn *conns;
extern Conn *conn_display, *conn_wm;
/* }}} */
